config/routes.rb
Rails.application.routes.draw do
  resources :recognitions
  resources :statistics
  root 'recognitions#index'

  # RSS feed
  get 'feed', to: 'recognitions#feed', as: :feed

  # OptOutLinks
  get '/optout/:key', to: 'opt_out_links#optout', as: :optout

  # Shib/AD auth
  get "/signin", to: 'sessions#new', as: :signin
  get "/auth/google_oauth2", as: :google_oauth2
  get "/auth/developer", to: 'sessions#developer', as: :developer
  match "/auth/google_oauth2/callback" => "sessions#google_oauth2", as: :callback, via: [:get, :post]
  match "/signout" => "sessions#destroy", as: :signout, via: [:get, :post]
  match "/auth/failure", to: 'sessions#failure', as: :failed_signin, via: [:get, :post]

  # Log out
  get 'logout', to: 'recognitions#logout', as: :logout

  mount LetterOpenerWeb::Engine, at: "/letter_opener" if ENV.fetch('APPS_H5_DELIVERY_METHOD', "").eql? "letter_opener_web"
end

app/models/recognition.rb
# frozen_string_literal: true

require 'digest/bubblebabble'

# Recognition
class Recognition < ApplicationRecord
  include Rails.application.routes.url_helpers

  after_create :generate_link
  after_create :notify_slack

  belongs_to :user
  belongs_to :employee

  validates :library_value, :description, presence: true

  # Custom scopes
  scope :most_recent, -> { order('created_at DESC') }
  scope :public_recognitions, -> { where(suppressed: false).most_recent }
  scope :all_recognitions, -> { all.most_recent }
  scope :feed, -> { public_recognitions.first(15) }

  # A custom finder used for identifying records created between a given date range
  # Note that the end date will be set to the end of the day, to allow for an inclusive search.
  # @param start_date [String] start date for query of form YYYY-MM-DD
  # @param end_date [String] end date for query of form YYYY-MM-DD
  def self.created_between(start_date, end_date)
    inclusive_end_date = Time.parse(end_date).end_of_day
    where(created_at: start_date..inclusive_end_date)
  end

  def generate_key(recognition_id)
    key = Digest::SHA1.bubblebabble(recognition_id.to_s + Time.zone.now.to_s)
    OptOutLink.new(key: key, recognition_id: recognition_id, expires: 6.months.from_now).save
    key
  end

  private

  # Generate an OptOutLink for this Recognition
  def generate_link
    logger.tagged('recognition') { logger.info "sending email for recognition #{id}" }
    generate_key(id)
    RecognitionMailer.email(Recognition.find(id)).deliver_now
  end

  def notify_slack
    SlackNotifier.call(employee_name: employee.display_name,
                       employee_rec_url: recognition_url(self))
  end
end

app/controllers/recognitions_controller.rb
# frozen_string_literal: true

# RecognitionsController
class RecognitionsController < ApplicationController
  include Pagy::Backend

  helper RecognitionsHelper
  before_action :require_user, only: %i[show index new edit create update destroy]
  before_action :set_recognition, only: %i[show edit update destroy]
  before_action :authorize_editor, only: %i[edit update destroy]

  # GET /recognitions
  # GET /recognitions.json
  def index
    @pagy, @recognitions = if valid_administrator?
                             pagy(Recognition.all_recognitions)
                           else
                             pagy(Recognition.public_recognitions)
                           end
  end

  # GET /feed.rss
  def feed
    @recognitions = Recognition.feed
    respond_to do |format|
      format.rss { render layout: false }
    end
  end

  # GET /recognitions/1
  # GET /recognitions/1.json
  def show; end

  # GET /recognitions/new
  def new
    @recognition = Recognition.new
  end

  # GET /recognitions/1/edit
  def edit; end

  # POST /recognitions
  # POST /recognitions.json
  # rubocop:disable Metrics/MethodLength
  def create
    @recognition = Recognition.new(recognition_params)
    @recognition.user = current_user
    respond_to do |format|
      if @recognition.save
        format.html { redirect_to @recognition, notice: 'Recognition was successfully created.' }
        format.json { render :show, status: :created, location: @recognition }
      else
        format.html { render :new }
        format.json { render json: @recognition.errors, status: :unprocessable_entity }
      end
    end
  end
  # rubocop:enable Metrics/MethodLength

  # PATCH/PUT /recognitions/1
  # PATCH/PUT /recognitions/1.json
  def update
    respond_to do |format|
      if @recognition.update(recognition_params)
        format.html { redirect_to @recognition, notice: 'Recognition was successfully updated.' }
        format.json { render :show, status: :ok, location: @recognition }
      else
        format.html { render :edit }
        format.json { render json: @recognition.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /recognitions/1
  # DELETE /recognitions/1.json
  def destroy
    @recognition.destroy
    respond_to do |format|
      format.html { redirect_to recognitions_url, notice: 'Recognition was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # GET /recognitions/logout
  def logout; end

  private

  # Ensure the current user is allowed to edit/update/delete the current recognition
  def authorize_editor
    # rubocop:disable Layout/LineLength
    redirect_to @recognition, notice: 'You are only allowed to modify your own recognitions' unless can_administrate?(@recognition)
    # rubocop:enable Layout/LineLength
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_recognition
    @recognition = Recognition.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def recognition_params
    params.require(:recognition).permit(:employee_id, :library_value,
                                        :description, :anonymous,
                                        :recognizer)
  end
end

app/helpers/recognitions_helper.rb
# frozen_string_literal: true

# RecognitionsHelper
module RecognitionsHelper
  include Pagy::Frontend

  def library_values
    # helper for form needs to be [label, value]
    LIBRARY_VALUES.to_a.map { |entry| [entry[1], entry[0]] }
  end

  #---
  # Reformat date string to fancy pants sentence (show view)
  #---
  def pretty_date(date)
    date = Date.parse(date.to_s)
    date.strftime("Given on the #{date.day.ordinalize} day of %B %Y")
  end

  #---
  # Reformat "Lastname, Firstanme" to "Firstname Lastname" (show view)
  #---
  def pretty_name(name)
    if name.count(',') == 1
      name = name.split(',', 2)
      name = "#{name[1]} #{name[0]}".strip
    end
    name
  end
end

app/views/recognitions/_form.html.erb
<%= simple_form_for(@recognition) do |f| %>

  <%= f.association :employee,
              label: 'The person you would like to recognize',
              error: 'Select an employee from the list',
              label_method: :display_name,
              collection: Employee.active_employees,
              prompt: 'Select one…' %>

  <%= f.input :library_value,
              label: 'The library value they embody',
              error: 'Select a library value from the list',
              prompt: 'Select one…',
              collection: library_values %>

  <%= f.input :description,
              label: 'Some kind words about this person',
              error: 'You need to tell us why this person deserves recognition' %>

  <%= f.input :anonymous,
              label: 'Please do not include my name with the post',
              hint: 'Your name will be shared with the person being recognized and their supervisor, but it will not be included in the post displayed on the LiSN home page'%>

	<% if defined?(form_mode) && form_mode == 'Edit' %>
		<%= f.button :submit, 'Edit the love', class: "btn-danger" %>
	<% else %>
		<%= f.button :submit, 'Share the love', class: "btn-primary" %>
	<% end %>

<% end %>

app/views/recognitions/_head.html.erb
<% content_for :head do%>
  <%= stylesheet_packs_with_chunks_tag("application") %>
  <%= javascript_packs_with_chunks_tag("application") %>
<% end %>

app/views/recognitions/edit.html.erb
<%= render 'head' %>
<h1>Edit Recognition</h1>
<p class="text-danger">You are about to edit an existing recognition. Are you sure this is something you want to do?</p>
<hr>

<%= render 'form', recognition: @recognition, form_mode: 'Edit' %>

app/views/recognitions/front.html.erb
<%= render 'head' %>
<p>
  <strong>Welcome to High Five!</strong>
</p>

<p>
  <%= link_to 'View Recognitions', recognitions_path, class: "btn btn-outline-primary"%>
</p>

<% if current_user && (current_user.developer? || valid_administrator?) %>
<p>
<%= link_to 'Generate Statistics', statistics_path, class: "btn btn-outline-primary"%>
</p>
<% end %>

<p>
<% if logged_in? %>
<%= link_to 'Sign out', signout_path, class: "btn btn-outline-secondary"%>
<% else %>
<%= link_to 'Sign in', signin_path, class: "btn btn-outline-secondary"%>
<% end %>
</p>

app/views/recognitions/index.html.erb
<%= render 'head' %>
<h1>Library Staff Recognitions</h1>
<% @recognitions.each do |recognition| %>
  <div class="le-fake-row shadow-sm">
    <div class="le-fake-cell">
      <p class="shrinky-dink"><b>To:</b> <%= recognition.employee.display_name %></p>
      <p class="shrinky-dink"><b>From:</b> <%= recognition.anonymous ? 'Anonymous' : recognition.user.full_name.titlecase %></p>
			<div class="push-in-a-little-bit">
        <b><%= LIBRARY_VALUES[ recognition.library_value ] %></b><br>
        <%= recognition.description.truncate(200, separator: '…') %>
			</div>
    </div>
    <div class="le-fake-cell">
      <div class="btn-toolbar" role="toolbar" aria-label="Toolbar with button groups">
        <div class="btn-group" role="group" aria-label="First group">
          <%= link_to 'View', recognition, class: 'btn btn-outline-secondary btn-sm'%>
          <% if can_administrate?(recognition) %>
            <%= link_to 'Edit', edit_recognition_path(recognition), class: 'btn btn-outline-secondary btn-sm' %>
            <%= link_to 'Delete', recognition, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-outline-secondary btn-sm' %>
          <% end %>
        </div>
      </div>
    </div>
  </div>
<% end %>

<!-- note the == is the same as 'raw' -->
<%== pagy_bootstrap_nav(@pagy) %>

app/views/recognitions/logout.html.erb
<%= render 'head' %>
<hr/>

app/views/recognitions/new.html.erb
<%= render 'head' %>
<h1>New Recognition</h1>
<p>Do you know a fellow employee who deserves a little recognition for their unsung accomplishments? Well then,
  you are in luck my friend, use this form to let us all know why you are grateful for their contributions to the
  Library.</p>
<p><em>A list of the most recent recognitions will be displayed on the LiSN home page.</em></p>
<hr>
<%= render 'form', recognition: @recognition %>

app/views/recognitions/show.html.erb
<%= render 'head' %>
<div id="hi5-award-wrapper">
  <div id="hi5-award">
    <div class="c1"><img src="https://library.ucsd.edu/assets/hi5/hi5.png" alt=""></div>
    <div class="c2">A High Five of Appreciation</div>
		<div class="c3">Is hereby presented to</div>
    <div class="c4"><%= pretty_name(@recognition.employee.display_name) %></div>
    <div class="c5">FOR <%= LIBRARY_VALUES[@recognition.library_value] %></div>
    <div class="c6"><%= @recognition.description %></div>
    <div class="c7"><%= pretty_date(@recognition.created_at) %></div>
    <div class="c8">Signed <%= @recognition.anonymous ? 'Anonymous' : pretty_name(@recognition.user.full_name) %></div>
  </div>
</div>

<% if can_administrate?(@recognition) %>
  <div class="lower-toolbar">
      <%= link_to 'Edit Recognition', edit_recognition_path(@recognition), class: 'btn btn-outline-secondary btn-sm' %>
  </div>
<% end %>